
// Configure the number of buttons.  Be careful not to use a pin for both a digital button and analog
// axis.  The pullup resistor will interfere with the analog voltage.
const int numButtons = 39;  
void setup() {
  Serial.begin(9600);
  Joystick.useManualSend(true);
  for (int i=0; i<numButtons; i++) {
    pinMode(i, INPUT_PULLUP);
  }
  Serial.println("Begin Complete Joystick Test");
}
byte allButtons[numButtons];
byte prevButtons[numButtons];
//predefine max and min values
int ymin = 300;
int xmin = 300;
int zmin = 300;
int zrmin = 300;
int ymax = 850;
int xmax = 850;
int zmax = 850;
int zrmax = 850;

void loop() {
//Set up use values
 int joyy = (analogRead(36));
 int joyx = (analogRead(37));
 int joyz = (1023-analogRead(38));
 int joyzr = (1023-analogRead(39));
//Auto calibrate max and min based on each use
 if (joyy > ymax) {ymax = joyy;}
 if (joyx > xmax) {xmax = joyx;}
 if (joyz > zmax) {zmax = joyz;}
 if (joyzr > zrmax) {zrmax = joyzr;}
 if (joyy < ymin) {ymin = joyy;}
 if (joyx < xmin) {xmin = joyx;}
 if (joyz < zmin) {zmin = joyz;}
 if (joyzr < zrmin) {zrmin = joyzr;}
//Remap values to fill range 0-1023
 joyy = map(joyy, ymin, ymax, 0, 1023);
 joyx = map(joyx, xmin, xmax, 0, 1023);
 //joyz = map(joyz, zmin, zmax, 0, 1023);
 //joyzr = map(joyzr, zrmin, zrmax, 0, 1023);
 //Check Dead Zones
 if (joyy > 412 && joyy < 612) {joyy = 512;}
 if (joyx > 412 && joyx < 612) {joyx = 512;}
 if (joyz > 412 && joyz < 612) {joyz = 512;}
 if (joyzr > 412 && joyzr < 612) {joyzr = 512;}
 //use values for input
  Joystick.Y(joyy);
  Joystick.X(joyx);
  Joystick.Z(joyz);
  Joystick.Zrotate(joyzr);

 //int val;
 // val = analogRead(37);
//  Serial.println(val);

Joystick.hat(-1);
 if (digitalRead(32)==LOW) { Joystick.hat(0);}
 if (digitalRead(33)==LOW) { Joystick.hat(180);}
 if (digitalRead(34)==LOW) { Joystick.hat(270);}
 if (digitalRead(35)==LOW) { Joystick.hat(90);}
  
    // read digital pins and use them for the buttons
  for (int i=0; i<numButtons; i++) {
    if (digitalRead(i)) {
      // when a pin reads high, the button is not pressed
      // the pullup resistor creates the "on" signal
      allButtons[i] = 0;
    } else {
      // when a pin reads low, the button is connecting to ground.
      allButtons[i] = 1;
    }
    Joystick.button(i + 1, allButtons[i]);
  }
  
  // Because setup configured the Joystick manual send, the computer does not see any of the changes yet.
  // This send_now() transmits everything all at once.
  Joystick.send_now();
  // check to see if any button changed since last time
  boolean anyChange = false;
  for (int i=0; i<numButtons; i++) {
    if (allButtons[i] != prevButtons[i]) anyChange = true;
    prevButtons[i] = allButtons[i];
  }
  
  // if any button changed, print them to the serial monitor
  if (anyChange) {
    Serial.print("Buttons: ");
    for (int i=0; i<numButtons; i++) {
      Serial.print(allButtons[i], DEC);
    }
    Serial.println();
  }
  
  // a brief delay, so this runs "only" 200 times per second
  delay(5);
}

